package com.monorailstudios.mengine;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;

public class MActor {

	MWorld world;
	Paint drawPaint;
	
	float x, y, dx, dy, d2x, d2y;
	int width, height;
	Rect hitBox;
	
	public MActor(float x, float y){
		this.x = x;
		this.y = y;
		
		drawPaint = new Paint();
		drawPaint.setColor(Color.GREEN);
		
		dx = 0;
		dy = 0;
		d2x = 0;
		d2y = 0;
		
		width = 100;
		height = 100;
		
		world = null;
		handleHitBox();
	}
	
	public void update(float dt){
		handleInput();
		handleMotion(dt);
		handleBounds();
		handleHitBox();
		checkCollisions();
		handleErrors();
	}
	
	public void render(Canvas canvas){
		canvas.drawRect(hitBox, drawPaint);
	}
	
	public void setWorld(MWorld world){
		this.world = world;
	}
	
	public void handleMotion(float dt){
		dx += d2x*dt;
		dy += d2y*dt;
		x += dx*dt;
		y += dy*dt;
	}
	
	private void handleHitBox(){
		hitBox = new Rect((int)x, (int)y, (int)x+width, (int)y+height);
	}
	
	public void addedToWorld(){}
	
	public void removedFromWorld(){}
	
	public void handleBounds(){}
	
	public void handleErrors(){}
	
	public void handleCollisions(MActor a){}
	
	public void handleInput(){}
	
	private void checkCollisions(){
		for(MActor a : world.getEntites()){
			if(hitBox.intersect(a.getHitBox())){
				handleCollisions(a);
			}
		}
	}
	
	public Rect getHitBox(){
		return hitBox;
	}
}
