package com.monorailstudios.mengine;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnTouchListener;

public class MView extends SurfaceView implements SurfaceHolder.Callback, OnTouchListener{

	private Paint debugPaint;
	private Paint refreshPaint;
	
	private float elapsedTime;
	private float dt;
	
	long previousTime;
	long currentTime;

	
	public MView(Context context, AttributeSet attrs) {
		super(context, attrs);
		getHolder().addCallback(this);
		
		refreshPaint = new Paint();
		debugPaint = new Paint();

		
		previousTime = System.currentTimeMillis();
		currentTime = previousTime;
		elapsedTime = currentTime;
		dt = elapsedTime/1000;
		
		setOnTouchListener(this);
		MEngine.init();
	}
	
	public void testing(){
		// Testing
		MWorld world = new MWorld(this);
		MActor a = new MActor(100, 100);

		MEngine.setWorld(world);
		world.add(a);
		
		a.dx = 100;
	}
	
	@Override
	protected void onSizeChanged(int w, int h, int oldw, int oldh){
		super.onSizeChanged(w, h, oldw, oldh);
		refreshPaint.setColor(Color.TRANSPARENT);
		
		debugPaint.setColor(Color.GREEN);
		debugPaint.setAntiAlias(true);
		debugPaint.setTextSize(24);
	}
	
	@Override
	protected void onDraw(Canvas canvas){
		super.onDraw(canvas);
		canvas.scale(canvas.getWidth()/1920f, canvas.getHeight()/1080f);
		currentTime = System.currentTimeMillis();
		elapsedTime = currentTime-previousTime;

		canvas.drawRect(0, 0, canvas.getWidth(), canvas.getWidth(), refreshPaint);
		
		dt = elapsedTime/1000; 
		
		MEngine.update(dt);
		MEngine.render(canvas);
		
		if(MEngine.DEBUG){
			canvas.drawText(Integer.toString((int)(1/dt)), 30, 34, debugPaint);
		}

		previousTime = currentTime;
		canvas.restore();
		invalidate();
	}

	@Override
	public boolean onTouch(View view, MotionEvent e) {
		return true;
	}

	@Override
	public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void surfaceCreated(SurfaceHolder arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder arg0) {
		// TODO Auto-generated method stub
		
	}

}
