package com.monorailstudios.mengine;

import java.util.ArrayList;

import android.graphics.Canvas;

public class MWorld {

	public MView view;
	
	public ArrayList<MActor> addable;
	public ArrayList<MActor> current;
	public ArrayList<MActor> removable;
	
	private int width, height;

	public MWorld(MView view){
		this.view = view;
		
		width = view.getWidth();
		height = view.getHeight();
		
		addable = new ArrayList<MActor>();
		current = new ArrayList<MActor>();
		removable = new ArrayList<MActor>();
	}

	public void add(MActor a){
		a.setWorld(this);
		addable.add(a);
	}

	public void remove(MActor a){
		if(!removable.contains(a))
			removable.add(a);
	}

	public void update(float dt){

		//Update All Actors
		for(MActor a : current){
			a.update(dt);
		}

		//Add All Actors
		for(MActor a : addable){
			current.add(a);
			a.addedToWorld();
		}
		addable.clear();

		//Remove All Actors
		for(MActor a : removable){
			current.remove(a);
			a.removedFromWorld();
		}
		removable.clear();
	}

	public void render(Canvas canvas){
		//Renders All Actors
		for(MActor a : current){
			a.render(canvas);
		}
	}

	public int getNumEntities(){
		return current.size();
	}
	
	public ArrayList<MActor> getEntites(){
		return current;
	}
}
